Overview | Package | Class | Use | Tree | Deprecated | Index | Help
| Eclipse Platform Release 3.0
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## org.eclipse.swt.widgets
Class List

    java.lang.Object
      org.eclipse.swt.widgets.Widget
          org.eclipse.swt.widgets.Control
              org.eclipse.swt.widgets.Scrollable
                  org.eclipse.swt.widgets.List

All Implemented Interfaces:
  Drawable

public class List
extends Scrollable

Instances of this class represent a selectable user interface object that displays a list of strings and issues notificiation when a string selected. A list may be single or multi select.

Styles:
  SINGLE, MULTI
Events:
  Selection, DefaultSelection

Note: Only one of SINGLE and MULTI may be specified.

IMPORTANT: This class is not intended to be subclassed.

Field Summary

Fields inherited from class org.eclipse.swt.widgets.Control
`handle`

Constructor Summary
`List(Composite parent, int style)` Constructs a new instance of this class given its parent and a style value describing its behavior and appearance.

Method Summary
`void` | `add(String string)` Adds the argument to the end of the receiver's list.
`void` | `add(String string, int index)` Adds the argument to the receiver's list at the given zero-relative index.
`void` | `addSelectionListener(SelectionListener listener)` Adds the listener to the collection of listeners who will be notified when the receiver's selection changes, by sending it one of the messages defined in the `SelectionListener` interface.
`Point` | `computeSize(int wHint, int hHint, boolean changed)` Returns the preferred size of the receiver.
`void` | `deselect(int index)` Deselects the item at the given zero-relative index in the receiver.
`void` | `deselect(int[] indices)` Deselects the items at the given zero-relative indices in the receiver.
`void` | `deselect(int start, int end)` Deselects the items at the given zero-relative indices in the receiver.
`void` | `deselectAll()` Deselects all selected items in the receiver.
`int` | `getFocusIndex()` Returns the zero-relative index of the item which currently has the focus in the receiver, or -1 if no item has focus.
`String` | `getItem(int index)` Returns the item at the given, zero-relative index in the receiver.
`int` | `getItemCount()` Returns the number of items contained in the receiver.
`int` | `getItemHeight()` Returns the height of the area which would be used to display one of the items in the tree.
`String[]` | `getItems()` Returns an array of `String`s which are the items in the receiver.
`String[]` | `getSelection()` Returns an array of `String`s that are currently selected in the receiver.
`int` | `getSelectionCount()` Returns the number of selected items contained in the receiver.
`int` | `getSelectionIndex()` Returns the zero-relative index of the item which is currently selected in the receiver, or -1 if no item is selected.
`int[]` | `getSelectionIndices()` Returns the zero-relative indices of the items which are currently selected in the receiver.
`int` | `getTopIndex()` Returns the zero-relative index of the item which is currently at the top of the receiver.
`int` | `indexOf(String string)` Gets the index of an item.
`int` | `indexOf(String string, int start)` Searches the receiver's list starting at the given, zero-relative index until an item is found that is equal to the argument, and returns the index of that item.
`boolean` | `isSelected(int index)` Returns `true` if the item is selected, and `false` otherwise.
`void` | `remove(int index)` Removes the item from the receiver at the given zero-relative index.
`void` | `remove(int[] indices)` Removes the items from the receiver at the given zero-relative indices.
`void` | `remove(int start, int end)` Removes the items from the receiver which are between the given zero-relative start and end indices (inclusive).
`void` | `remove(String string)` Searches the receiver's list starting at the first item until an item is found that is equal to the argument, and removes that item from the list.
`void` | `removeAll()` Removes all of the items from the receiver.
`void` | `removeSelectionListener(SelectionListener listener)` Removes the listener from the collection of listeners who will be notified when the receiver's selection changes.
`void` | `select(int index)` Selects the item at the given zero-relative index in the receiver's list.
`void` | `select(int[] indices)` Selects the items at the given zero-relative indices in the receiver.
`void` | `select(int start, int end)` Selects the items in the range specified by the given zero-relative indices in the receiver.
`void` | `selectAll()` Selects all of the items in the receiver.
`void` | `setFont(Font font)` Sets the font that the receiver will use to paint textual information to the font specified by the argument, or to the default font for that kind of control if the argument is null.
`void` | `setItem(int index, String string)` Sets the text of the item in the receiver's list at the given zero-relative index to the string argument.
`void` | `setItems(String[] items)` Sets the receiver's items to be the given array of items.
`void` | `setSelection(int index)` Selects the item at the given zero-relative index in the receiver.
`void` | `setSelection(int[] indices)` Selects the items at the given zero-relative indices in the receiver.
`void` | `setSelection(int start, int end)` Selects the items in the range specified by the given zero-relative indices in the receiver.
`void` | `setSelection(String[] items)` Sets the receiver's selection to be the given array of items.
`void` | `setTopIndex(int index)` Sets the zero-relative index of the item which is currently at the top of the receiver.
`void` | `showSelection()` Shows the selection.

Methods inherited from class org.eclipse.swt.widgets.Scrollable
`computeTrim, getClientArea, getHorizontalBar, getVerticalBar`

Methods inherited from class org.eclipse.swt.widgets.Control
`addControlListener, addFocusListener, addHelpListener, addKeyListener, addMouseListener, addMouseMoveListener, addMouseTrackListener, addPaintListener, addTraverseListener, computeSize, forceFocus, getAccessible, getBackground, getBorderWidth, getBounds, getEnabled, getFont, getForeground, getLayoutData, getLocation, getMenu, getMonitor, getParent, getShell, getSize, getToolTipText, getVisible, internal_dispose_GC, internal_new_GC, isEnabled, isFocusControl, isReparentable, isVisible, moveAbove, moveBelow, pack, pack, redraw, redraw, removeControlListener, removeFocusListener, removeHelpListener, removeKeyListener, removeMouseListener, removeMouseMoveListener, removeMouseTrackListener, removePaintListener, removeTraverseListener, setBackground, setBounds, setBounds, setCapture, setCursor, setEnabled, setFocus, setForeground, setLayoutData, setLocation, setLocation, setMenu, setParent, setRedraw, setSize, setSize, setToolTipText, setVisible, toControl, toControl, toDisplay, toDisplay, traverse, update`

Methods inherited from class org.eclipse.swt.widgets.Widget
`addDisposeListener, addListener, checkSubclass, checkWidget, dispose, getData, getData, getDisplay, getStyle, isDisposed, isListening, notifyListeners, removeDisposeListener, removeListener, removeListener, setData, setData, toString`

Methods inherited from class java.lang.Object
`clone, equals, finalize, getClass, hashCode, notify, notifyAll, wait, wait, wait`

Constructor Detail

### List

    public List(Composite parent,
                int style)

  Constructs a new instance of this class given its parent and a style value describing its behavior and appearance.

  The style value is either one of the style constants defined in class `SWT` which is applicable to instances of this class, or must be built by bitwise OR'ing together (that is, using the `int` "|" operator) two or more of those `SWT` style constants. The class description lists the style constants that are applicable to the class. Style bits are also inherited from superclasses.

Parameters:
  `parent` - a composite control which will be the parent of the new instance (cannot be null)
  `style` - the style of control to construct
Throws:
  `IllegalArgumentException` -
  - ERROR_NULL_ARGUMENT - if the parent is null
  `SWTException` -
  - ERROR_THREAD_INVALID_ACCESS - if not called from the thread that created the parent
  - ERROR_INVALID_SUBCLASS - if this class is not an allowed subclass
See Also:
  `SWT.SINGLE`, `SWT.MULTI`, `Widget.checkSubclass()`, `Widget.getStyle()`

Method Detail

### add

    public void add(String string)

  Adds the argument to the end of the receiver's list.

  Parameters:
    `string` - the new item
  Throws:
    `IllegalArgumentException` -
    - ERROR_NULL_ARGUMENT - if the string is null
    `SWTException` -
    - ERROR_WIDGET_DISPOSED - if the receiver has been disposed
    - ERROR_THREAD_INVALID_ACCESS - if not called from the thread that created the receiver
    `SWTError` -
    - ERROR_ITEM_NOT_ADDED - if the operation fails because of an operating system failure
  See Also:
    `add(String,int)`

### add

    public void add(String string,
                    int index)

  Adds the argument to the receiver's list at the given zero-relative index.

  Note: To add an item at the end of the list, use the result of calling `getItemCount()` as the index or use `add(String)`.

  Parameters:
    `string` - the new item
    `index` - the index for the item
  Throws:
    `IllegalArgumentException` -
    - ERROR_NULL_ARGUMENT - if the string is null
    - ERROR_INVALID_RANGE - if the index is not between 0 and the number of elements in the list (inclusive)
    `SWTException` -
    - ERROR_WIDGET_DISPOSED - if the receiver has been disposed
    - ERROR_THREAD_INVALID_ACCESS - if not called from the thread that created the receiver
    `SWTError` -
    - ERROR_ITEM_NOT_ADDED - if the operation fails because of an operating system failure
  See Also:
    `add(String)`

### addSelectionListener

    public void addSelectionListener(SelectionListener listener)

  Adds the listener to the collection of listeners who will be notified when the receiver's selection changes, by sending it one of the messages defined in the `SelectionListener` interface.

  `widgetSelected` is called when the selection changes. `widgetDefaultSelected` is typically called when an item is double-clicked.

  Parameters:
    `listener` - the listener which should be notified
  Throws:
    `IllegalArgumentException` -
    - ERROR_NULL_ARGUMENT - if the listener is null
    `SWTException` -
    - ERROR_WIDGET_DISPOSED - if the receiver has been disposed
    - ERROR_THREAD_INVALID_ACCESS - if not called from the thread that created the receiver
  See Also:
    `SelectionListener`, `removeSelectionListener(org.eclipse.swt.events.SelectionListener)`, `SelectionEvent`

### computeSize

    public Point computeSize(int wHint,
                             int hHint,
                             boolean changed)

  Description copied from class: `Control`
  Returns the preferred size of the receiver.

  The preferred size of a control is the size that it would best be displayed at. The width hint and height hint arguments allow the caller to ask a control questions such as "Given a particular width, how high does the control need to be to show all of the contents?" To indicate that the caller does not wish to constrain a particular dimension, the constant `SWT.DEFAULT` is passed for the hint.

  If the changed flag is `true`, it indicates that the receiver's contents have changed, therefore any caches that a layout manager containing the control may have been keeping need to be flushed. When the control is resized, the changed flag will be `false`, so layout manager caches can be retained.

  Overrides:
    `computeSize` in class `Control`
  Parameters:
    `wHint` - the width hint (can be `SWT.DEFAULT`)
    `hHint` - the height hint (can be `SWT.DEFAULT`)
    `changed` - `true` if the control's contents have changed, and `false` otherwise
  Returns:
    the preferred size of the control.
  See Also:
    `Layout`, `Control.getBorderWidth()`, `Control.getBounds()`, `Control.getSize()`, `Control.pack()`, "computeTrim, getClientArea for controls that implement them"

### deselect

    public void deselect(int[] indices)

  Deselects the items at the given zero-relative indices in the receiver. If the item at the given zero-relative index in the receiver is selected, it is deselected. If the item at the index was not selected, it remains deselected. Indices that are out of range and duplicate indices are ignored.

  Parameters:
    `indices` - the array of indices for the items to deselect
  Throws:
    `IllegalArgumentException` -
    - ERROR_NULL_ARGUMENT - if the set of indices is null
    `SWTException` -
    - ERROR_WIDGET_DISPOSED - if the receiver has been disposed
    - ERROR_THREAD_INVALID_ACCESS - if not called from the thread that created the receiver

### deselect

    public void deselect(int index)

  Deselects the item at the given zero-relative index in the receiver. If the item at the index was already deselected, it remains deselected. Indices that are out of range are ignored.

  Parameters:
    `index` - the index of the item to deselect
  Throws:
    `SWTException` -
    - ERROR_WIDGET_DISPOSED - if the receiver has been disposed
    - ERROR_THREAD_INVALID_ACCESS - if not called from the thread that created the receiver

### deselect

    public void deselect(int start,
                         int end)

  Deselects the items at the given zero-relative indices in the receiver. If the item at the given zero-relative index in the receiver is selected, it is deselected. If the item at the index was not selected, it remains deselected. The range of the indices is inclusive. Indices that are out of range are ignored.

  Parameters:
    `start` - the start index of the items to deselect
    `end` - the end index of the items to deselect
  Throws:
    `SWTException` -
    - ERROR_WIDGET_DISPOSED - if the receiver has been disposed
    - ERROR_THREAD_INVALID_ACCESS - if not called from the thread that created the receiver

### deselectAll

    public void deselectAll()

  Deselects all selected items in the receiver.

  Throws:
    `SWTException` -
    - ERROR_WIDGET_DISPOSED - if the receiver has been disposed
    - ERROR_THREAD_INVALID_ACCESS - if not called from the thread that created the receiver

### getFocusIndex

    public int getFocusIndex()

  Returns the zero-relative index of the item which currently has the focus in the receiver, or -1 if no item has focus.

  Returns:
    the index of the selected item
  Throws:
    `SWTException` -
    - ERROR_WIDGET_DISPOSED - if the receiver has been disposed
    - ERROR_THREAD_INVALID_ACCESS - if not called from the thread that created the receiver

### getItem

    public String getItem(int index)

  Returns the item at the given, zero-relative index in the receiver. Throws an exception if the index is out of range.

  Parameters:
    `index` - the index of the item to return
  Returns:
    the item at the given index
  Throws:
    `IllegalArgumentException` -
    - ERROR_INVALID_RANGE - if the index is not between 0 and the number of elements in the list minus 1 (inclusive)
    `SWTException` -
    - ERROR_WIDGET_DISPOSED - if the receiver has been disposed
    - ERROR_THREAD_INVALID_ACCESS - if not called from the thread that created the receiver
    `SWTError` -
    - ERROR_CANNOT_GET_ITEM - if the operation fails because of an operating system failure

### getItemCount

    public int getItemCount()

  Returns the number of items contained in the receiver.

  Returns:
    the number of items
  Throws:
    `SWTException` -
    - ERROR_WIDGET_DISPOSED - if the receiver has been disposed
    - ERROR_THREAD_INVALID_ACCESS - if not called from the thread that created the receiver
    `SWTError` -
    - ERROR_CANNOT_GET_COUNT - if the operation fails because of an operating system failure

### getItemHeight

    public int getItemHeight()

  Returns the height of the area which would be used to display one of the items in the tree.

  Returns:
    the height of one item
  Throws:
    `SWTException` -
    - ERROR_WIDGET_DISPOSED - if the receiver has been disposed
    - ERROR_THREAD_INVALID_ACCESS - if not called from the thread that created the receiver
    `SWTError` -
    - ERROR_CANNOT_GET_ITEM_HEIGHT - if the operation fails because of an operating system failure

### getItems

    public String[] getItems()

  Returns an array of `String`s which are the items in the receiver.

  Note: This is not the actual structure used by the receiver to maintain its list of items, so modifying the array will not affect the receiver.

  Returns:
    the items in the receiver's list
  Throws:
    `SWTException` -
    - ERROR_WIDGET_DISPOSED - if the receiver has been disposed
    - ERROR_THREAD_INVALID_ACCESS - if not called from the thread that created the receiver
    `SWTError` -
    - ERROR_CANNOT_GET_ITEM - if the operation fails because of an operating system failure while getting an item
    - ERROR_CANNOT_GET_COUNT - if the operation fails because of an operating system failure while getting the item count

### getSelection

    public String[] getSelection()

  Returns an array of `String`s that are currently selected in the receiver. An empty array indicates that no items are selected.

  Note: This is not the actual structure used by the receiver to maintain its selection, so modifying the array will not affect the receiver.

  Returns:
    an array representing the selection
  Throws:
    `SWTException` -
    - ERROR_WIDGET_DISPOSED - if the receiver has been disposed
    - ERROR_THREAD_INVALID_ACCESS - if not called from the thread that created the receiver
    `SWTError` -
    - ERROR_CANNOT_GET_SELECTION - if the operation fails because of an operating system failure while getting the selection
    - ERROR_CANNOT_GET_ITEM - if the operation fails because of an operating system failure while getting an item

### getSelectionCount

    public int getSelectionCount()

  Returns the number of selected items contained in the receiver.

  Returns:
    the number of selected items
  Throws:
    `SWTException` -
    - ERROR_WIDGET_DISPOSED - if the receiver has been disposed
    - ERROR_THREAD_INVALID_ACCESS - if not called from the thread that created the receiver
    `SWTError` -
    - ERROR_CANNOT_GET_COUNT - if the operation fails because of an operating system failure

### getSelectionIndex

    public int getSelectionIndex()

  Returns the zero-relative index of the item which is currently selected in the receiver, or -1 if no item is selected.

  Returns:
    the index of the selected item
  Throws:
    `SWTException` -
    - ERROR_WIDGET_DISPOSED - if the receiver has been disposed
    - ERROR_THREAD_INVALID_ACCESS - if not called from the thread that created the receiver
    `SWTError` -
    - ERROR_CANNOT_GET_SELECTION - if the operation fails because of an operating system failure

### getSelectionIndices

    public int[] getSelectionIndices()

  Returns the zero-relative indices of the items which are currently selected in the receiver. The array is empty if no items are selected.

  Note: This is not the actual structure used by the receiver to maintain its selection, so modifying the array will not affect the receiver.

  Returns:
    the array of indices of the selected items
  Throws:
    `SWTException` -
    - ERROR_WIDGET_DISPOSED - if the receiver has been disposed
    - ERROR_THREAD_INVALID_ACCESS - if not called from the thread that created the receiver
    `SWTError` -
    - ERROR_CANNOT_GET_SELECTION - if the operation fails because of an operating system failure

### getTopIndex

    public int getTopIndex()

  Returns the zero-relative index of the item which is currently at the top of the receiver. This index can change when items are scrolled or new items are added or removed.

  Returns:
    the index of the top item
  Throws:
    `SWTException` -
    - ERROR_WIDGET_DISPOSED - if the receiver has been disposed
    - ERROR_THREAD_INVALID_ACCESS - if not called from the thread that created the receiver

### indexOf

    public int indexOf(String string)

  Gets the index of an item.

  The list is searched starting at 0 until an item is found that is equal to the search item. If no item is found, -1 is returned. Indexing is zero based.

  Parameters:
    `string` - the search item
  Returns:
    the index of the item
  Throws:
    `IllegalArgumentException` -
    - ERROR_NULL_ARGUMENT - if the string is null
    `SWTException` -
    - ERROR_WIDGET_DISPOSED - if the receiver has been disposed
    - ERROR_THREAD_INVALID_ACCESS - if not called from the thread that created the receiver

### indexOf

    public int indexOf(String string,
                       int start)

  Searches the receiver's list starting at the given, zero-relative index until an item is found that is equal to the argument, and returns the index of that item. If no item is found or the starting index is out of range, returns -1.

  Parameters:
    `string` - the search item
    `start` - the zero-relative index at which to start the search
  Returns:
    the index of the item
  Throws:
    `IllegalArgumentException` -
    - ERROR_NULL_ARGUMENT - if the string is null
    `SWTException` -
    - ERROR_WIDGET_DISPOSED - if the receiver has been disposed
    - ERROR_THREAD_INVALID_ACCESS - if not called from the thread that created the receiver
    `SWTError` -
    - ERROR_CANNOT_GET_COUNT - if the operation fails because of an operating system failure while getting the item count
    - ERROR_CANNOT_GET_ITEM - if the operation fails because of an operating system failure while getting an item

### isSelected

    public boolean isSelected(int index)

  Returns `true` if the item is selected, and `false` otherwise. Indices out of range are ignored.

  Parameters:
    `index` - the index of the item
  Returns:
    the visibility state of the item at the index
  Throws:
    `SWTException` -
    - ERROR_WIDGET_DISPOSED - if the receiver has been disposed
    - ERROR_THREAD_INVALID_ACCESS - if not called from the thread that created the receiver

### remove

    public void remove(int[] indices)

  Removes the items from the receiver at the given zero-relative indices.

  Parameters:
    `indices` - the array of indices of the items
  Throws:
    `IllegalArgumentException` -
    - ERROR_INVALID_RANGE - if the index is not between 0 and the number of elements in the list minus 1 (inclusive)
    - ERROR_NULL_ARGUMENT - if the indices array is null
    `SWTException` -
    - ERROR_WIDGET_DISPOSED - if the receiver has been disposed
    - ERROR_THREAD_INVALID_ACCESS - if not called from the thread that created the receiver
    `SWTError` -
    - ERROR_ITEM_NOT_REMOVED - if the operation fails because of an operating system failure

### remove

    public void remove(int index)

  Removes the item from the receiver at the given zero-relative index.

  Parameters:
    `index` - the index for the item
  Throws:
    `IllegalArgumentException` -
    - ERROR_INVALID_RANGE - if the index is not between 0 and the number of elements in the list minus 1 (inclusive)
    `SWTException` -
    - ERROR_WIDGET_DISPOSED - if the receiver has been disposed
    - ERROR_THREAD_INVALID_ACCESS - if not called from the thread that created the receiver
    `SWTError` -
    - ERROR_ITEM_NOT_REMOVED - if the operation fails because of an operating system failure

### remove

    public void remove(int start,
                       int end)

  Removes the items from the receiver which are between the given zero-relative start and end indices (inclusive).

  Parameters:
    `start` - the start of the range
    `end` - the end of the range
  Throws:
    `IllegalArgumentException` -
    - ERROR_INVALID_RANGE - if either the start or end are not between 0 and the number of elements in the list minus 1 (inclusive)
    `SWTException` -
    - ERROR_WIDGET_DISPOSED - if the receiver has been disposed
    - ERROR_THREAD_INVALID_ACCESS - if not called from the thread that created the receiver
    `SWTError` -
    - ERROR_ITEM_NOT_REMOVED - if the operation fails because of an operating system failure

### remove

    public void remove(String string)

  Searches the receiver's list starting at the first item until an item is found that is equal to the argument, and removes that item from the list.

  Parameters:
    `string` - the item to remove
  Throws:
    `IllegalArgumentException` -
    - ERROR_NULL_ARGUMENT - if the string is null
    - ERROR_INVALID_ARGUMENT - if the string is not found in the list
    `SWTException` -
    - ERROR_WIDGET_DISPOSED - if the receiver has been disposed
    - ERROR_THREAD_INVALID_ACCESS - if not called from the thread that created the receiver
    `SWTError` -
    - ERROR_ITEM_NOT_REMOVED - if the operation fails because of an operating system failure

### removeAll

    public void removeAll()

  Removes all of the items from the receiver.

  Throws:
    `SWTException` -
    - ERROR_WIDGET_DISPOSED - if the receiver has been disposed
    - ERROR_THREAD_INVALID_ACCESS - if not called from the thread that created the receiver

### removeSelectionListener

    public void removeSelectionListener(SelectionListener listener)

  Removes the listener from the collection of listeners who will be notified when the receiver's selection changes.

  Parameters:
    `listener` - the listener which should no longer be notified
  Throws:
    `IllegalArgumentException` -
    - ERROR_NULL_ARGUMENT - if the listener is null
    `SWTException` -
    - ERROR_WIDGET_DISPOSED - if the receiver has been disposed
    - ERROR_THREAD_INVALID_ACCESS - if not called from the thread that created the receiver
  See Also:
    `SelectionListener`, `addSelectionListener(org.eclipse.swt.events.SelectionListener)`

### select

    public void select(int[] indices)

  Selects the items at the given zero-relative indices in the receiver. The current selection is not cleared before the new items are selected.

  If the item at a given index is not selected, it is selected. If the item at a given index was already selected, it remains selected. Indices that are out of range and duplicate indices are ignored. If the receiver is single-select and multiple indices are specified, then all indices are ignored.

  Parameters:
    `indices` - the array of indices for the items to select
  Throws:
    `IllegalArgumentException` -
    - ERROR_NULL_ARGUMENT - if the array of indices is null
    `SWTException` -
    - ERROR_WIDGET_DISPOSED - if the receiver has been disposed
    - ERROR_THREAD_INVALID_ACCESS - if not called from the thread that created the receiver
  See Also:
    `setSelection(int[])`

### select

    public void select(int index)

  Selects the item at the given zero-relative index in the receiver's list. If the item at the index was already selected, it remains selected. Indices that are out of range are ignored.

  Parameters:
    `index` - the index of the item to select
  Throws:
    `SWTException` -
    - ERROR_WIDGET_DISPOSED - if the receiver has been disposed
    - ERROR_THREAD_INVALID_ACCESS - if not called from the thread that created the receiver

### select

    public void select(int start,
                       int end)

  Selects the items in the range specified by the given zero-relative indices in the receiver. The range of indices is inclusive. The current selection is not cleared before the new items are selected.

  If an item in the given range is not selected, it is selected. If an item in the given range was already selected, it remains selected. Indices that are out of range are ignored and no items will be selected if start is greater than end. If the receiver is single-select and there is more than one item in the given range, then all indices are ignored.

  Parameters:
    `start` - the start of the range
    `end` - the end of the range
  Throws:
    `SWTException` -
    - ERROR_WIDGET_DISPOSED - if the receiver has been disposed
    - ERROR_THREAD_INVALID_ACCESS - if not called from the thread that created the receiver
  See Also:
    `setSelection(int,int)`

### selectAll

    public void selectAll()

  Selects all of the items in the receiver.

  If the receiver is single-select, do nothing.

  Throws:
    `SWTException` -
    - ERROR_WIDGET_DISPOSED - if the receiver has been disposed
    - ERROR_THREAD_INVALID_ACCESS - if not called from the thread that created the receiver

### setFont

    public void setFont(Font font)

  Description copied from class: `Control`
  Sets the font that the receiver will use to paint textual information to the font specified by the argument, or to the default font for that kind of control if the argument is null.

  Overrides:
    `setFont` in class `Control`
  Parameters:
    `font` - the new font (or null)

### setItem

    public void setItem(int index,
                        String string)

  Sets the text of the item in the receiver's list at the given zero-relative index to the string argument. This is equivalent to `remove`'ing the old item at the index, and then `add`'ing the new item at that index.

  Parameters:
    `index` - the index for the item
    `string` - the new text for the item
  Throws:
    `IllegalArgumentException` -
    - ERROR_INVALID_RANGE - if the index is not between 0 and the number of elements in the list minus 1 (inclusive)
    - ERROR_NULL_ARGUMENT - if the string is null
    `SWTException` -
    - ERROR_WIDGET_DISPOSED - if the receiver has been disposed
    - ERROR_THREAD_INVALID_ACCESS - if not called from the thread that created the receiver
    `SWTError` -
    - ERROR_ITEM_NOT_REMOVED - if the remove operation fails because of an operating system failure
    - ERROR_ITEM_NOT_ADDED - if the add operation fails because of an operating system failure

### setItems

    public void setItems(String[] items)

  Sets the receiver's items to be the given array of items.

  Parameters:
    `items` - the array of items
  Throws:
    `IllegalArgumentException` -
    - ERROR_NULL_ARGUMENT - if the items array is null
    `SWTException` -
    - ERROR_WIDGET_DISPOSED - if the receiver has been disposed
    - ERROR_THREAD_INVALID_ACCESS - if not called from the thread that created the receiver
    `SWTError` -
    - ERROR_ITEM_NOT_ADDED - if the operation fails because of an operating system failure

### setSelection

    public void setSelection(int[] indices)

  Selects the items at the given zero-relative indices in the receiver. The current selection is cleared before the new items are selected.

  Indices that are out of range and duplicate indices are ignored. If the receiver is single-select and multiple indices are specified, then all indices are ignored.

  Parameters:
    `indices` - the indices of the items to select
  Throws:
    `IllegalArgumentException` -
    - ERROR_NULL_ARGUMENT - if the array of indices is null
    `SWTException` -
    - ERROR_WIDGET_DISPOSED - if the receiver has been disposed
    - ERROR_THREAD_INVALID_ACCESS - if not called from the thread that created the receiver
  See Also:
    `deselectAll()`, `select(int[])`

### setSelection

    public void setSelection(String[] items)

  Sets the receiver's selection to be the given array of items. The current selection is cleared before the new items are selected.

  Items that are not in the receiver are ignored. If the receiver is single-select and multiple items are specified, then all items are ignored.

  Parameters:
    `items` - the array of items
  Throws:
    `IllegalArgumentException` -
    - ERROR_NULL_ARGUMENT - if the array of items is null
    `SWTException` -
    - ERROR_WIDGET_DISPOSED - if the receiver has been disposed
    - ERROR_THREAD_INVALID_ACCESS - if not called from the thread that created the receiver
  See Also:
    `deselectAll()`, `select(int[])`, `setSelection(int[])`

### setSelection

    public void setSelection(int index)

  Selects the item at the given zero-relative index in the receiver. If the item at the index was already selected, it remains selected. The current selected is first cleared, then the new items are selected. Indices that are out of range are ignored.

  Parameters:
    `index` - the index of the item to select
  Throws:
    `SWTException` -
    - ERROR_WIDGET_DISPOSED - if the receiver has been disposed
    - ERROR_THREAD_INVALID_ACCESS - if not called from the thread that created the receiver
  See Also:
    `deselectAll()`, `select(int)`

### setSelection

    public void setSelection(int start,
                             int end)

  Selects the items in the range specified by the given zero-relative indices in the receiver. The range of indices is inclusive. The current selection is cleared before the new items are selected.

  Indices that are out of range are ignored and no items will be selected if start is greater than end. If the receiver is single-select and there is more than one item in the given range, then all indices are ignored.

  Parameters:
    `start` - the start index of the items to select
    `end` - the end index of the items to select
  Throws:
    `SWTException` -
    - ERROR_WIDGET_DISPOSED - if the receiver has been disposed
    - ERROR_THREAD_INVALID_ACCESS - if not called from the thread that created the receiver
  See Also:
    `deselectAll()`, `select(int,int)`

### setTopIndex

    public void setTopIndex(int index)

  Sets the zero-relative index of the item which is currently at the top of the receiver. This index can change when items are scrolled or new items are added and removed.

  Parameters:
    `index` - the index of the top item
  Throws:
    `SWTException` -
    - ERROR_WIDGET_DISPOSED - if the receiver has been disposed
    - ERROR_THREAD_INVALID_ACCESS - if not called from the thread that created the receiver

### showSelection

    public void showSelection()

  Shows the selection. If the selection is already showing in the receiver, this method simply returns. Otherwise, the items are scrolled until the selection is visible.

  Throws:
    `SWTException` -
    - ERROR_WIDGET_DISPOSED - if the receiver has been disposed
    - ERROR_THREAD_INVALID_ACCESS - if not called from the thread that created the receiver

Overview | Package | Class | Use | Tree | Deprecated | Index | Help
| Eclipse Platform Release 3.0
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

Guidelines for using Eclipse APIs.

Copyright (c) IBM Corp. and others 2000, 2004. All rights reserved.